package suspendtest;

import java.util.Properties;

import javax.jms.JMSException;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class TopicClient {
	protected Context context = null;
	private TopicConnectionFactory topicConnectionFactory;
	protected Topic topic;
	private TopicConnection topicConnection;
	protected TopicSession topicSession;

	public TopicClient(String host) {
		context = getInitialContext(host);
		try {
			topicConnectionFactory = (TopicConnectionFactory) context.lookup("ConnectionFactory");
			try {
				topic = (Topic) context.lookup("topic/exampleTopic");
				topicConnection = topicConnectionFactory.createTopicConnection();
				topicSession = topicConnection.createTopicSession(false, TopicSession.AUTO_ACKNOWLEDGE);
				topicConnection.start();
			} catch (JMSException e) {
				e.printStackTrace();
			}
		} catch (NamingException e) {
			e.printStackTrace();
		}
	}
	
	private final Context getInitialContext(String host) {
		Properties props = new Properties();
		props.setProperty("java.naming.factory.initial", "org.jnp.interfaces.NamingContextFactory");
		props.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming:org.jnp.interfaces");
		props.setProperty("java.naming.provider.url", "jnp://" + host + ":1099");
		Context context;
		try {
			context = new InitialContext(props);
			return context;
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return null;
	}

	protected void close() {
		try {
			topicConnection.close();
		} catch (JMSException e) {
			e.printStackTrace();
		}
		if (context != null) {
			try {
				context.close();
			} catch (NamingException e) {
				e.printStackTrace();
			}
		}
	}

}
